﻿// <auto-generated />
using System;
using Jfdi.ProjectManagement.Api;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

namespace Jfdi.ProjectManagement.Api.Migrations
{
    [DbContext(typeof(JfdiDbContext))]
    [Migration("20210617042849_TaskStates")]
    partial class TaskStates
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .UseIdentityByDefaultColumns()
                .HasAnnotation("Relational:MaxIdentifierLength", 63)
                .HasAnnotation("ProductVersion", "5.0.2");

            modelBuilder.Entity("ClientServiceType", b =>
                {
                    b.Property<Guid>("ClientsId")
                        .HasColumnType("uuid");

                    b.Property<Guid>("ServiceTypesId")
                        .HasColumnType("uuid");

                    b.HasKey("ClientsId", "ServiceTypesId");

                    b.HasIndex("ServiceTypesId");

                    b.ToTable("ClientServiceType");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Attachment", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("CreatedAtUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid>("CreatedById")
                        .HasColumnType("uuid");

                    b.Property<string>("Name")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<Guid?>("ServiceId")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("ServiceInstanceId")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("SoftwareId")
                        .HasColumnType("uuid");

                    b.Property<string>("Type")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("CreatedById");

                    b.HasIndex("ServiceId");

                    b.HasIndex("ServiceInstanceId");

                    b.HasIndex("SoftwareId");

                    b.ToTable("Attachments");

                    b.HasDiscriminator<string>("Type").HasValue("None");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Blocker", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("CalendarEventId")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("CreatedAtUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid>("CreatedById")
                        .HasColumnType("uuid");

                    b.Property<Guid>("TaskId")
                        .HasColumnType("uuid");

                    b.Property<string>("Title")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.HasKey("Id");

                    b.HasIndex("CalendarEventId");

                    b.HasIndex("CreatedById");

                    b.HasIndex("TaskId");

                    b.ToTable("Blockers");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Calendar", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("CreatedAtUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid>("CreatedById")
                        .HasColumnType("uuid");

                    b.Property<uint>("xmin")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("xid");

                    b.HasKey("Id");

                    b.HasIndex("CreatedById");

                    b.ToTable("Calendars");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.CalendarEvent", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<Guid>("CalendarId")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("CreatedAtUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid>("CreatedById")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("EndUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<string>("RecurrenceRule")
                        .HasColumnType("text");

                    b.Property<DateTime>("StartUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<string>("Title")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<uint>("xmin")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("xid");

                    b.HasKey("Id");

                    b.HasIndex("CalendarId");

                    b.HasIndex("CreatedById");

                    b.ToTable("CalendarEvents");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Client", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("CalendarId")
                        .HasColumnType("uuid");

                    b.Property<string>("CityRegistration")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("ClientJfdiEmails")
                        .HasColumnType("text");

                    b.Property<string>("ClientTag")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("CompanyEin")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("CompanyName")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<DateTime>("CreatedAtUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid>("CreatedById")
                        .HasColumnType("uuid");

                    b.Property<DateTime?>("DateFormed")
                        .HasColumnType("timestamp without time zone");

                    b.Property<string>("Duns")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<DateTime?>("InitialTransactionProcessingDate")
                        .HasColumnType("timestamp without time zone");

                    b.Property<string>("MailingAddress")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("OnePasswordClientAcronoym")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("Phone")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("PhysicalAddress")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("President")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("RegisteredAgent")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<DateTime?>("ServiceStartDate")
                        .HasColumnType("timestamp without time zone");

                    b.Property<string>("Software")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("StateRegistration")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<Guid?>("TaxClassificationId")
                        .HasColumnType("uuid");

                    b.Property<string>("Tresurer")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<DateTime?>("YearEndDate")
                        .HasColumnType("timestamp without time zone");

                    b.Property<uint>("xmin")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("xid");

                    b.HasKey("Id");

                    b.HasIndex("CalendarId");

                    b.HasIndex("CompanyName")
                        .IsUnique();

                    b.HasIndex("CreatedById");

                    b.HasIndex("TaxClassificationId");

                    b.ToTable("Clients");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Comment", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("CreatedAtUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid>("CreatedById")
                        .HasColumnType("uuid");

                    b.Property<string>("Data")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<Guid?>("TaskInstanceId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("CreatedById");

                    b.HasIndex("TaskInstanceId");

                    b.ToTable("Comments");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Service", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("CreatedAtUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid>("CreatedById")
                        .HasColumnType("uuid");

                    b.Property<string>("Description")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<bool>("IsHighPriority")
                        .HasColumnType("boolean");

                    b.Property<string>("Links")
                        .HasColumnType("text");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("Recurring")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<Guid?>("ServiceTypeId")
                        .HasColumnType("uuid");

                    b.Property<uint>("xmin")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("xid");

                    b.HasKey("Id");

                    b.HasIndex("CreatedById");

                    b.HasIndex("ServiceTypeId");

                    b.ToTable("Services");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.ServiceInstance", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<Guid>("ClientId")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("CreatedAtUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid>("CreatedById")
                        .HasColumnType("uuid");

                    b.Property<string>("Description")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<bool>("IsHighPriority")
                        .HasColumnType("boolean");

                    b.Property<string>("Links")
                        .HasColumnType("text");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<Guid?>("TemplateId")
                        .HasColumnType("uuid");

                    b.Property<uint>("xmin")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("xid");

                    b.HasKey("Id");

                    b.HasIndex("ClientId");

                    b.HasIndex("CreatedById");

                    b.HasIndex("TemplateId");

                    b.ToTable("ServiceInstances");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.ServiceType", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<string>("Color")
                        .IsRequired()
                        .HasMaxLength(10)
                        .HasColumnType("character varying(10)");

                    b.Property<string>("FillIcon")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("Icon")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.HasKey("Id");

                    b.ToTable("ServiceTypes");

                    b.HasData(
                        new
                        {
                            Id = new Guid("a7db5845-babc-4230-ae13-ca4d865db6a6"),
                            Color = "#EBBB38",
                            FillIcon = "bookkeeping-fill",
                            Icon = "bookkeeping",
                            Name = "Bookkeeping"
                        },
                        new
                        {
                            Id = new Guid("ed17ca07-fb2e-4204-86b6-9de0d0e3e5da"),
                            Color = "#8F56CB",
                            FillIcon = "month-end-close-fill",
                            Icon = "month-end-close",
                            Name = "Month End Close"
                        },
                        new
                        {
                            Id = new Guid("4681430b-752d-4520-8372-6f41e3918469"),
                            Color = "#65A9D9",
                            FillIcon = "ap-fill",
                            Icon = "ap",
                            Name = "Accounts Payables"
                        },
                        new
                        {
                            Id = new Guid("9e8940ec-4317-4a2b-a1dd-668827943a99"),
                            Color = "#5DC5BE",
                            FillIcon = "ar-fill",
                            Icon = "ar",
                            Name = "Accounts Receivables"
                        },
                        new
                        {
                            Id = new Guid("9e8940ec-4317-4a2b-a1dd-668827943a98"),
                            Color = "#DB669E",
                            FillIcon = "payroll-fill",
                            Icon = "payroll",
                            Name = "Payroll"
                        },
                        new
                        {
                            Id = new Guid("9e8940ec-4317-4a2b-a1dd-668827943a78"),
                            Color = "#8BC465",
                            FillIcon = "reporting-fill",
                            Icon = "reporting",
                            Name = "Reporting"
                        },
                        new
                        {
                            Id = new Guid("9e8940ec-4317-4a2b-a1dd-668827943a10"),
                            Color = "#E26C35",
                            FillIcon = "compliance-fill",
                            Icon = "compliance",
                            Name = "Compliance"
                        },
                        new
                        {
                            Id = new Guid("9e8940ec-4317-4a2b-a1dd-668827943a43"),
                            Color = "#707070",
                            FillIcon = "project-fill",
                            Icon = "project",
                            Name = "Special Projects"
                        });
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Software", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("CreatedAtUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid>("CreatedById")
                        .HasColumnType("uuid");

                    b.Property<string>("Description")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("Links")
                        .HasColumnType("text");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<Guid?>("ServiceId")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("ServiceInstanceId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("CreatedById");

                    b.HasIndex("ServiceId");

                    b.HasIndex("ServiceInstanceId");

                    b.ToTable("Softwares");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Task", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("CreatedAtUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid>("CreatedById")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("DueDateUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<bool>("ForReview")
                        .HasColumnType("boolean");

                    b.Property<string>("Info")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<Guid?>("ParentId")
                        .HasColumnType("uuid");

                    b.Property<int>("Recurring")
                        .HasColumnType("integer");

                    b.Property<int>("Role")
                        .HasColumnType("integer");

                    b.Property<Guid?>("ServiceId")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("SupervisorId")
                        .HasColumnType("uuid");

                    b.Property<string>("Title")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<uint>("xmin")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("xid");

                    b.HasKey("Id");

                    b.HasIndex("CreatedById");

                    b.HasIndex("ParentId");

                    b.HasIndex("ServiceId");

                    b.HasIndex("SupervisorId");

                    b.ToTable("Tasks");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.TaskInstance", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("CreatedAtUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid>("CreatedById")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("DueDateUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid?>("EventId")
                        .HasColumnType("uuid");

                    b.Property<bool>("IsHighPriority")
                        .HasColumnType("boolean");

                    b.Property<string>("Links")
                        .HasColumnType("text");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<Guid?>("ParentId")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("ServiceId")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("SoftwareId")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("StateId")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("TemplateId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("CreatedById");

                    b.HasIndex("EventId");

                    b.HasIndex("ParentId");

                    b.HasIndex("ServiceId");

                    b.HasIndex("SoftwareId");

                    b.HasIndex("StateId");

                    b.HasIndex("TemplateId");

                    b.ToTable("TaskInstances");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.TaskState", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<string>("Title")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.HasKey("Id");

                    b.ToTable("TaskStates");

                    b.HasData(
                        new
                        {
                            Id = new Guid("a7db5845-babc-4230-ae13-ca4d865db6a6"),
                            Title = "TO-DO"
                        },
                        new
                        {
                            Id = new Guid("b62cb356-de5a-444b-85d4-4c5ca05793b6"),
                            Title = "In progress"
                        },
                        new
                        {
                            Id = new Guid("5994906d-4759-4a07-b6eb-62ba7348ea5e"),
                            Title = "Blocked"
                        },
                        new
                        {
                            Id = new Guid("0366dac4-b435-475d-ba85-96ba8a112981"),
                            Title = "For review"
                        },
                        new
                        {
                            Id = new Guid("f6550273-0245-4180-b5e6-425c88d892bd"),
                            Title = "Done"
                        });
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.TaxClassification", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<string>("Title")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.HasKey("Id");

                    b.ToTable("TaxClassifications");

                    b.HasData(
                        new
                        {
                            Id = new Guid("a7db5845-babc-4230-ae13-ca4d865db6a6"),
                            Title = "C-Corp"
                        },
                        new
                        {
                            Id = new Guid("4681430b-752d-4520-8372-6f41e3918469"),
                            Title = "Partnership"
                        },
                        new
                        {
                            Id = new Guid("ed17ca07-fb2e-4204-86b6-9de0d0e3e5da"),
                            Title = "S-Corp"
                        },
                        new
                        {
                            Id = new Guid("9e8940ec-4317-4a2b-a1dd-668827943a99"),
                            Title = "Single member LLC"
                        });
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.TeamMember", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<string>("Address")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<DateTime?>("BirthDate")
                        .HasColumnType("timestamp without time zone");

                    b.Property<string>("CellPhone")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<Guid?>("ClientId")
                        .HasColumnType("uuid");

                    b.Property<string>("CompanyMailingAddress")
                        .HasColumnType("text");

                    b.Property<DateTime>("CreatedAtUtc")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid>("CreatedById")
                        .HasColumnType("uuid");

                    b.Property<string>("Degree")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<bool>("EmailConfirmed")
                        .HasColumnType("boolean");

                    b.Property<string>("FirstName")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("FullName")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("LastName")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("NameOfCollege")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("Phone")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("PhysicalAddress")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<string>("Role")
                        .IsRequired()
                        .HasColumnType("character varying(30)");

                    b.Property<string>("Salary")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<int?>("SocialSecurityNumber")
                        .HasColumnType("integer");

                    b.Property<DateTime?>("StartDate")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid?>("SupervisorId")
                        .HasColumnType("uuid");

                    b.Property<string>("Title")
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<Guid>("UserId")
                        .HasColumnType("uuid");

                    b.Property<uint>("xmin")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("xid");

                    b.HasKey("Id");

                    b.HasIndex("ClientId");

                    b.HasIndex("CreatedById");

                    b.HasIndex("SupervisorId");

                    b.ToTable("TeamMembers");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.User", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("timestamp without time zone");

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.HasKey("Id");

                    b.HasIndex("Email")
                        .IsUnique();

                    b.ToTable("Users");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Attachments.DirectAttachment", b =>
                {
                    b.HasBaseType("Jfdi.ProjectManagement.Api.Models.Attachment");

                    b.Property<byte[]>("Data")
                        .IsRequired()
                        .HasColumnType("bytea");

                    b.HasDiscriminator().HasValue("Direct");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Attachments.GDriveAttachment", b =>
                {
                    b.HasBaseType("Jfdi.ProjectManagement.Api.Models.Attachment");

                    b.Property<string>("Link")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasDiscriminator().HasValue("GoogleDrive");
                });

            modelBuilder.Entity("ClientServiceType", b =>
                {
                    b.HasOne("Jfdi.ProjectManagement.Api.Models.Client", null)
                        .WithMany()
                        .HasForeignKey("ClientsId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.ServiceType", null)
                        .WithMany()
                        .HasForeignKey("ServiceTypesId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Attachment", b =>
                {
                    b.HasOne("Jfdi.ProjectManagement.Api.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.Service", null)
                        .WithMany("Attachments")
                        .HasForeignKey("ServiceId");

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.ServiceInstance", null)
                        .WithMany("Attachments")
                        .HasForeignKey("ServiceInstanceId");

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.Software", null)
                        .WithMany("Attachments")
                        .HasForeignKey("SoftwareId");

                    b.Navigation("CreatedBy");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Blocker", b =>
                {
                    b.HasOne("Jfdi.ProjectManagement.Api.Models.CalendarEvent", "CalendarEvent")
                        .WithMany()
                        .HasForeignKey("CalendarEventId");

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.TaskInstance", "Task")
                        .WithMany("Blockers")
                        .HasForeignKey("TaskId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("CalendarEvent");

                    b.Navigation("CreatedBy");

                    b.Navigation("Task");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Calendar", b =>
                {
                    b.HasOne("Jfdi.ProjectManagement.Api.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("CreatedBy");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.CalendarEvent", b =>
                {
                    b.HasOne("Jfdi.ProjectManagement.Api.Models.Calendar", "Calendar")
                        .WithMany("CalendarEvents")
                        .HasForeignKey("CalendarId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Calendar");

                    b.Navigation("CreatedBy");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Client", b =>
                {
                    b.HasOne("Jfdi.ProjectManagement.Api.Models.Calendar", "Calendar")
                        .WithMany()
                        .HasForeignKey("CalendarId");

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.TaxClassification", "TaxClassification")
                        .WithMany()
                        .HasForeignKey("TaxClassificationId");

                    b.Navigation("Calendar");

                    b.Navigation("CreatedBy");

                    b.Navigation("TaxClassification");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Comment", b =>
                {
                    b.HasOne("Jfdi.ProjectManagement.Api.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.TaskInstance", null)
                        .WithMany("Comments")
                        .HasForeignKey("TaskInstanceId");

                    b.Navigation("CreatedBy");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Service", b =>
                {
                    b.HasOne("Jfdi.ProjectManagement.Api.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.ServiceType", "ServiceType")
                        .WithMany()
                        .HasForeignKey("ServiceTypeId");

                    b.Navigation("CreatedBy");

                    b.Navigation("ServiceType");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.ServiceInstance", b =>
                {
                    b.HasOne("Jfdi.ProjectManagement.Api.Models.Client", "Client")
                        .WithMany("Services")
                        .HasForeignKey("ClientId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.Service", "Template")
                        .WithMany()
                        .HasForeignKey("TemplateId");

                    b.Navigation("Client");

                    b.Navigation("CreatedBy");

                    b.Navigation("Template");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Software", b =>
                {
                    b.HasOne("Jfdi.ProjectManagement.Api.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.Service", null)
                        .WithMany("Softwares")
                        .HasForeignKey("ServiceId");

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.ServiceInstance", null)
                        .WithMany("Softwares")
                        .HasForeignKey("ServiceInstanceId");

                    b.Navigation("CreatedBy");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Task", b =>
                {
                    b.HasOne("Jfdi.ProjectManagement.Api.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.Task", "Parent")
                        .WithMany("Children")
                        .HasForeignKey("ParentId");

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.Service", null)
                        .WithMany("Tasks")
                        .HasForeignKey("ServiceId");

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.TeamMember", "Supervisor")
                        .WithMany()
                        .HasForeignKey("SupervisorId");

                    b.Navigation("CreatedBy");

                    b.Navigation("Parent");

                    b.Navigation("Supervisor");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.TaskInstance", b =>
                {
                    b.HasOne("Jfdi.ProjectManagement.Api.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.CalendarEvent", "Event")
                        .WithMany()
                        .HasForeignKey("EventId");

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.TaskInstance", "Parent")
                        .WithMany("Children")
                        .HasForeignKey("ParentId");

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.ServiceInstance", "Service")
                        .WithMany("Tasks")
                        .HasForeignKey("ServiceId");

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.Software", "Software")
                        .WithMany()
                        .HasForeignKey("SoftwareId");

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.TaskState", "State")
                        .WithMany()
                        .HasForeignKey("StateId");

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.Task", "Template")
                        .WithMany()
                        .HasForeignKey("TemplateId");

                    b.Navigation("CreatedBy");

                    b.Navigation("Event");

                    b.Navigation("Parent");

                    b.Navigation("Service");

                    b.Navigation("Software");

                    b.Navigation("State");

                    b.Navigation("Template");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.TeamMember", b =>
                {
                    b.HasOne("Jfdi.ProjectManagement.Api.Models.Client", null)
                        .WithMany("TeamMemberAssignments")
                        .HasForeignKey("ClientId");

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Jfdi.ProjectManagement.Api.Models.TeamMember", "Supervisor")
                        .WithMany()
                        .HasForeignKey("SupervisorId");

                    b.Navigation("CreatedBy");

                    b.Navigation("Supervisor");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Calendar", b =>
                {
                    b.Navigation("CalendarEvents");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Client", b =>
                {
                    b.Navigation("Services");

                    b.Navigation("TeamMemberAssignments");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Service", b =>
                {
                    b.Navigation("Attachments");

                    b.Navigation("Softwares");

                    b.Navigation("Tasks");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.ServiceInstance", b =>
                {
                    b.Navigation("Attachments");

                    b.Navigation("Softwares");

                    b.Navigation("Tasks");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Software", b =>
                {
                    b.Navigation("Attachments");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.Task", b =>
                {
                    b.Navigation("Children");
                });

            modelBuilder.Entity("Jfdi.ProjectManagement.Api.Models.TaskInstance", b =>
                {
                    b.Navigation("Blockers");

                    b.Navigation("Children");

                    b.Navigation("Comments");
                });
#pragma warning restore 612, 618
        }
    }
}
